Source-Changes-HG archive
[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]
[src/trunk]: src/tests/sbin/ifconfig Add test cases for different 802.11 opti...
details: https://anonhg.NetBSD.org/src/rev/51156f8a6d3c
branches: trunk
changeset: 1011347:51156f8a6d3c
user: jruoho <jruoho%NetBSD.org@localhost>
date: Sat Jun 27 05:07:07 2020 +0000
description:
Add test cases for different 802.11 options. These include cases for
PR kern/35045, PR kern/45745, and PR kern/55424.
diffstat:
distrib/sets/lists/tests/mi | 3 +-
tests/sbin/ifconfig/Makefile | 9 +-
tests/sbin/ifconfig/t_woptions.sh | 208 ++++++++++++++++++++++++++++++++++++++
3 files changed, 217 insertions(+), 3 deletions(-)
diffs (249 lines):
diff -r 8983b881bc7f -r 51156f8a6d3c distrib/sets/lists/tests/mi
--- a/distrib/sets/lists/tests/mi Sat Jun 27 04:31:06 2020 +0000
+++ b/distrib/sets/lists/tests/mi Sat Jun 27 05:07:07 2020 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: mi,v 1.854 2020/06/25 18:30:42 jruoho Exp $
+# $NetBSD: mi,v 1.855 2020/06/27 05:07:07 jruoho Exp $
#
# Note: don't delete entries from here - mark them as "obsolete" instead.
#
@@ -3999,6 +3999,7 @@
./usr/tests/sbin/ifconfig/t_repeated_scan tests-sbin-tests compattestfile,atf
./usr/tests/sbin/ifconfig/t_repeated_updown tests-sbin-tests compattestfile,atf
./usr/tests/sbin/ifconfig/t_tap tests-sbin-tests compattestfile,atf
+./usr/tests/sbin/ifconfig/t_woptions tests-sbin-tests compattestfile,atf
./usr/tests/sbin/newfs tests-sbin-tests compattestfile,atf
./usr/tests/sbin/newfs/Atffile tests-sbin-tests compattestfile,atf
./usr/tests/sbin/newfs/Kyuafile tests-sbin-tests compattestfile,atf,kyua
diff -r 8983b881bc7f -r 51156f8a6d3c tests/sbin/ifconfig/Makefile
--- a/tests/sbin/ifconfig/Makefile Sat Jun 27 04:31:06 2020 +0000
+++ b/tests/sbin/ifconfig/Makefile Sat Jun 27 05:07:07 2020 +0000
@@ -1,9 +1,14 @@
-# $NetBSD: Makefile,v 1.5 2020/06/25 18:30:42 jruoho Exp $
+# $NetBSD: Makefile,v 1.6 2020/06/27 05:07:07 jruoho Exp $
.include <bsd.own.mk>
TESTSDIR= ${TESTSBASE}/sbin/ifconfig
-TESTS_SH= t_bridge t_nonexistent t_repeated_scan t_repeated_updown t_tap
+TESTS_SH= t_bridge \
+ t_nonexistent \
+ t_repeated_scan \
+ t_repeated_updown \
+ t_tap \
+ t_woptions
.include <bsd.test.mk>
diff -r 8983b881bc7f -r 51156f8a6d3c tests/sbin/ifconfig/t_woptions.sh
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/sbin/ifconfig/t_woptions.sh Sat Jun 27 05:07:07 2020 +0000
@@ -0,0 +1,208 @@
+# $NetBSD: t_woptions.sh,v 1.1 2020/06/27 05:07:08 jruoho Exp $
+#
+# Copyright (c) 2020 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# This code is derived from software contributed to The NetBSD Foundation
+# by Jukka Ruohonen.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+atf_test_case chan
+chan_head() {
+ atf_set "require.user" "root"
+ atf_set "descr" "Test with ifconfig(8) that setting " \
+ "802.11 channels does not panic (PR kern/55424)"
+}
+
+chan_body() {
+
+ # This sequence covers both valid and invalid channels.
+ # Different 802.11 modes are not taken into account, and
+ # all interfaces are tested, including non-802.11 ones.
+ #
+ chans=$(seq 1 500)
+
+ pkill -9 hostapd
+ pkill -9 wpa_supplicant
+
+ for i in $(ifconfig -l); do
+
+ if [ ! -z "$(echo $i | grep urtwn)" ]; then
+ echo "Skipping $i (PR kern/55424)"
+ continue
+ fi
+
+ state="up"
+ ifconfig -s $i
+
+ if [ $? -eq 1 ]; then
+ state="down"
+ fi
+
+ m=""
+ mm=$(ifconfig $i | grep "chan")
+
+ if [ ! -z "$mm" ]; then
+ m=$(echo $mm | awk {'print $2'})
+ fi
+
+ for j in $chans; do
+ echo "Request: $i -> 802.11 chan $j"
+ ifconfig $i chan $j >/dev/null 2>&1
+ echo "Request: $i -> 802.11 -chan $j"
+ ifconfig $i -chan $j >/dev/null 2>&1
+ done
+
+ if [ ! -z $m ]; then
+ ifconfig $i chan $m >/dev/null 2>&1
+ echo "Restored the channel of $i to $m"
+ fi
+
+ ifconfig $i $state
+ echo "Restored state of $i to $state"
+ sleep 1
+ done
+
+ /bin/sh /etc/rc.d/hostapd restart >/dev/null 2>&1
+ /bin/sh /etc/rc.d/wpa_supplicant restart >/dev/null 2>&1
+
+ atf_pass
+}
+
+atf_test_case mediaopt
+mediaopt_head() {
+ atf_set "require.user" "root"
+ atf_set "descr" "Test with ifconfig(8) that setting " \
+ "802.11 media options does not panic (PR kern/35045)"
+}
+
+mediaopt_body() {
+
+ # Again, also non-802.11 interfaces are tested.
+ #
+ opts="adhoc monitor hostap"
+
+ pkill -9 hostapd
+ pkill -9 wpa_supplicant
+
+ for i in $(ifconfig -l); do
+
+ state="up"
+ ifconfig -s $i
+
+ if [ $? -eq 1 ]; then
+ state="down"
+ fi
+
+ m=""
+ mm=$(ifconfig $i | grep "media")
+
+ for j in $opts; do
+
+ match=$(echo $mm | grep $j)
+
+ if [ ! -z "$match" ]; then
+ m=$j
+ break
+ fi
+ done
+
+ for j in $opts; do
+ echo "Request: $i -> 802.11 mediaopt $j"
+ ifconfig $i mediaopt $j >/dev/null 2>&1
+ echo "Request: $i -> 802.11 -mediaopt $j"
+ ifconfig $i -mediaopt $j >/dev/null 2>&1
+ done
+
+ if [ ! -z $m ]; then
+ ifconfig $i mode $m >/dev/null 2>&1
+ echo "Restored the mediaopt of $i to $m"
+ fi
+
+ ifconfig $i $state
+ echo "Restored state of $i to $state"
+ sleep 1
+ done
+
+ /bin/sh /etc/rc.d/hostapd restart >/dev/null 2>&1
+ /bin/sh /etc/rc.d/wpa_supplicant restart >/dev/null 2>&1
+
+ atf_pass
+}
+
+atf_test_case modes
+modes_head() {
+ atf_set "require.user" "root"
+ atf_set "descr" "Test with ifconfig(8) that setting " \
+ "802.11 modes does not panic (PR kern/45745)"
+}
+
+modes_body() {
+
+ # Although 11n is not yet supported, the system
+ # should not panic from invalid input parameters.
+ # Therefore, the following will try to also set
+ # the four 802.11 modes for non-802.11 devices.
+ #
+ modes="11a 11b 11g 11n"
+
+ pkill -9 hostapd
+ pkill -9 wpa_supplicant
+
+ for i in $(ifconfig -l); do
+
+ m=""
+ mm=$(ifconfig $i | grep "media")
+
+ for j in $modes; do
+
+ match=$(echo $mm | grep $j)
+
+ if [ ! -z "$match" ]; then
+ m=$j
+ break
+ fi
+ done
+
+ for j in $modes; do
+ echo "Request: $i -> 802.11 mode $j"
+ ifconfig $i mode $j >/dev/null 2>&1
+ done
+
+ if [ ! -z $m ]; then
+ ifconfig $i mode $m >/dev/null 2>&1
+ echo "Restored the mode of $i to $m"
+ fi
+ done
+
+ /bin/sh /etc/rc.d/hostapd restart >/dev/null 2>&1
+ /bin/sh /etc/rc.d/wpa_supplicant restart >/dev/null 2>&1
+
+ atf_pass
+}
+
+atf_init_test_cases() {
+ atf_add_test_case chan
+ atf_add_test_case mediaopt
+ atf_add_test_case modes
+}
Home |
Main Index |
Thread Index |
Old Index